library(bayestraitr)
library(ape)
library(paleotree )
library(phylobase)
library(phytools)
library(geosphere)
load('GTree_phylo4g_withClimateSimData.RDat')
d = bt_read.log("Anc_Tones_continuous_est.Log.txt")



tree.chosen = tree4d
tips.to.remove  = tree4d@label[is.na(tree4d@data[1:length(tree4d@label),]$Tones)]
tree.chosen = prune(tree.chosen,tips.exclude = tips.to.remove, trim.internal=T)

anc = apply(d[,grepl("^Est",names(d))],2,mean)
ancsd = apply(d[,grepl("^Est",names(d))],2,sd)


newdf = as.data.frame(tree.chosen@data)
newdf$node = 1:nrow(newdf)
newdf = newdf[,c('node', 'Longitude', 'Latitude', 'specH.mean', "Node.Age", 'Tones', 'specH.mean.sim.gam')]
newdf$Tones.sd = 0

newdf$Tones[211] = 2
newdf$Tones.sd[211] = 0
newdf$Tones[212:419] = anc
newdf$Tones.sd[212:419] = ancsd

ancinfo = tree.chosen@edge

newdf$ancTones = NA
newdf$ancTones.sd = NA
newdf$mH = NA
newdf$ancAge = NA
newdf$ancnode = NA

for (i in 1:max(newdf$node)) {
  anc = ancinfo[ancinfo[,2] == i,1][[1]]
  newdf$ancnode[i] = anc
  if(anc > 0){
    newdf$ancTones[newdf$node == i] = newdf$Tones[newdf$node == anc]
    newdf$ancTones.sd[newdf$node == i] = newdf$Tones.sd[newdf$node == anc]
    newdf$mH[newdf$node == i] = mean(newdf$specH.mean.sim.gam[newdf$node == anc], newdf$specH.mean.sim.gam[newdf$node == i])
    newdf$ancAge[newdf$node == i] = newdf$Node.Age[newdf$node == anc]

    
  }

}

newdf$deltaAge = newdf$ancAge-newdf$Node.Age

#251-252
#0.0033354911

#333.54911
for(i in 1:nrow(newdf)){
  tmp = tree.chosen@edge.length[paste(c(newdf$ancnode[i], newdf$node[i]), collapse = '-' )]
  newdf$deltaAge[i] = (333.54911/0.0033354911)*tmp[[1]]
}


get_extants <- function(age){

  agesdf$node[which(agesdf$age_upper >= age+0.01 & agesdf$age_lower <= age+0.01)]
  
}
ancinfo = tree.chosen@edge
ancinfo_age = ancinfo
agesdf = data.frame()
for (i in newdf$node){
  tmpdf = ancinfo_age[which(ancinfo_age[,2] == i),]
  if (tmpdf[1] == 0){
    agesdf = rbind(agesdf, data.frame('node' = i, 'age_upper' = Inf, 'age_lower' = newdf$Node.Age[which(newdf$node %in% tmpdf[2])]))
  }else{
    agesdf = rbind(agesdf, data.frame('node' = i, 'age_upper' = newdf$Node.Age[which(newdf$node == tmpdf[1])], 'age_lower' = newdf$Node.Age[which(newdf$node %in% tmpdf[2])]))
  }
}


geodist = distm(newdf[,c('Longitude','Latitude')], fun = distHaversine)/1000000
geodist = exp(-8 * geodist^2 )

weighted_means =c()

for(i in 1:nrow(newdf)){
  print(i/nrow(newdf))
  
  tonesdf = newdf[which(newdf$node %in% get_extants(newdf$Node.Age[i])), c('Tones', 'node', 'ancTones') ]
  tonesdf$weights = NA
  for(e in 1:nrow(tonesdf)){
    tonesdf$weights[e] = geodist[i, tonesdf$node[e]]
  }
  
  tonesdf$dtones = tonesdf$Tones-tonesdf$ancTones
  tonesdf = tonesdf[tonesdf$node != newdf$node[i],]
  weighted_means = c(weighted_means, weighted.mean(tonesdf$dtones, tonesdf$weights))
  
}


newdf$neighbourmean = weighted_means


library(ecoPD)
phydist = ecoPD::pairdist(tree.chosen)*10
phydist = exp(-10 * phydist )

weighted_phymeans =c()

for(i in 1:nrow(newdf)){
  print(i/nrow(newdf))
  
  tonesdf = newdf[which(newdf$node %in% get_extants(newdf$Node.Age[i])), c('Tones', 'node', 'ancTones') ]
  tonesdf$weights = NA
  for(e in 1:nrow(tonesdf)){
    tonesdf$weights[e] = phydist[i, tonesdf$node[e]]
  }

  tonesdf = tonesdf[tonesdf$node != newdf$node[i],]
  weighted_phymeans = c(weighted_phymeans, weighted.mean(tonesdf$Tones, tonesdf$weights))
  
}

newdf$phymean = weighted_phymeans


weighted_means_int =c()

for(i in 1:nrow(newdf)){
  print(i/nrow(newdf))

  tonesdf = newdf[which(newdf$node %in% get_extants(newdf$Node.Age[i])), c('Tones', 'node', 'ancTones', 'Node.Age', 'ancAge') ]
  tonesdf$weights = NA
  for(e in 1:nrow(tonesdf)){
    tonesdf$weights[e] = geodist[i, tonesdf$node[e]]
  }
  tonesdf$cutprop = NA
  for(e in 1:nrow(tonesdf)){
    tonesdf$cutprop[e] = 1-(newdf$Node.Age[i]-tonesdf$Node.Age[e])/(tonesdf$ancAge[e]-tonesdf$Node.Age[e])
  }
  tonesdf = tonesdf[tonesdf$node != newdf$node[i],]
  tonesdf$Tones = tonesdf$ancTones + (tonesdf$Tones-tonesdf$ancTones)*tonesdf$cutprop
  weighted_means_int = c(weighted_means_int, weighted.mean(tonesdf$Tones, tonesdf$weights))
  
}


newdf$neighbourmean_int = weighted_means_int


weighted_phymeans_int =c()

for(i in 1:nrow(newdf)){
  print(i/nrow(newdf))
  
  tonesdf = newdf[which(newdf$node %in% get_extants(newdf$Node.Age[i])), c('Tones', 'node', 'ancTones', 'Node.Age', 'ancAge') ]
  tonesdf$weights = NA
  for(e in 1:nrow(tonesdf)){
    tonesdf$weights[e] = phydist[i, tonesdf$node[e]]
  }
  tonesdf$cutprop = NA
  for(e in 1:nrow(tonesdf)){
    tonesdf$cutprop[e] = 1-(newdf$Node.Age[i]-tonesdf$Node.Age[e])/(tonesdf$ancAge[e]-tonesdf$Node.Age[e])
  }
  tonesdf = tonesdf[tonesdf$node != newdf$node[i],]
  tonesdf$dTones = (tonesdf$Tones-tonesdf$ancTones)*tonesdf$cutprop
  weighted_phymeans_int = c(weighted_phymeans_int, weighted.mean(tonesdf$dTones, tonesdf$weights))
  
}

newdf$phymean_int = weighted_phymeans_int



weighted_phyrate_abs =c()
weighted_phyrate =c()
phyrate_disc =c()
phyrate_disc_sd = c()
for(i in 1:nrow(newdf)){
  print(i/nrow(newdf))
  
  tonesdf = newdf
  
  tonesdf$deltaAge = tonesdf$deltaAge/1000
  tonesdf$dTones = tonesdf$Tones-tonesdf$ancTones
  tonesdf$rate = tonesdf$dTones/tonesdf$deltaAge
  tonesdf$rate_abs = abs(tonesdf$rate)
  tonesdf$weights = NA
  for(e in 1:nrow(tonesdf)){
    tonesdf$weights[e] = phydist[i, tonesdf$node[e]]
  }

  tonesdf = tonesdf[tonesdf$node != newdf$node[i],]
  tonesdf = tonesdf[!is.na(tonesdf$mH),]
  weighted_phyrate_abs = c(weighted_phyrate_abs, weighted.mean(tonesdf$rate_abs, tonesdf$weights))
  weighted_phyrate = c(weighted_phyrate, weighted.mean(tonesdf$rate, tonesdf$weights))
  
  
  tmpphylo = phydist[i,]
  tonesdf = newdf
  tonesdf = tonesdf[which(tonesdf$node %in% which(tmpphylo < 0.02)),]
  
  tonesdf$deltaAge = tonesdf$deltaAge/1000
  tonesdf$dTones = tonesdf$Tones-tonesdf$ancTones
  tonesdf$rate = tonesdf$dTones/tonesdf$deltaAge
  tonesdf$rate_abs = abs(tonesdf$rate)
  tonesdf = tonesdf[tonesdf$node != newdf$node[i],]
  tonesdf = tonesdf[!is.na(tonesdf$mH),]
  phyrate_disc = c(phyrate_disc, mean(tonesdf$rate))
  phyrate_disc_sd = c(phyrate_disc_sd, sd(tonesdf$rate))
}

newdf$phyrate_abs = weighted_phyrate_abs
newdf$phyrate = weighted_phyrate

newdf$phyrate_disc = phyrate_disc
newdf$phyrate_disc_sd = phyrate_disc_sd



geodist = distm(newdf[,c('Longitude','Latitude')], fun = distHaversine)/1000000
disc_means_int =c()
disc_meds_int =c()
disc_means_int_sd=c()
for(i in 1:nrow(newdf)){
  print(i/nrow(newdf))
  
  tonesdf = newdf[which(newdf$node %in% get_extants(newdf$Node.Age[i])), c('Tones', 'node', 'ancTones', 'Node.Age', 'ancAge') ]
  tmpgeo = geodist[i,]
  tonesdf = tonesdf[which(tonesdf$node %in% which(tmpgeo < 0.5)),]
  tonesdf$cutprop = NA
  for(e in 1:nrow(tonesdf)){
    tonesdf$cutprop[e] = 1-(newdf$Node.Age[i]-tonesdf$Node.Age[e])/(tonesdf$ancAge[e]-tonesdf$Node.Age[e])
  }
  tonesdf = tonesdf[tonesdf$node != newdf$node[i],]
  tonesdf$Tones = tonesdf$ancTones + (tonesdf$Tones-tonesdf$ancTones)*tonesdf$cutprop
  disc_means_int = c(disc_means_int, mean(tonesdf$Tones))
  disc_meds_int = c(disc_meds_int, median(tonesdf$Tones))
  disc_means_int_sd = c(disc_means_int_sd, sd(tonesdf$Tones))
  
}

newdf$disc_neighbourmeans_int_sd = disc_means_int_sd
newdf$disc_neighbourmeans_int = disc_means_int
newdf$disc_neighbourmed_int = disc_meds_int


phydist = ecoPD::pairdist(tree.chosen)
disc_phymeans_int2 =c()
disc_phymeans_int =c()
disc_phymed_int =c()
disc_phymeans_int_sd =c()
for(i in 1:nrow(newdf)){
  print(i/nrow(newdf))
  
  tonesdf = newdf
  tmpphylo = phydist[i,]
  tonesdf = tonesdf[which(tonesdf$node %in% which(tmpphylo < 0.02)),]
  tonesdf = tonesdf[tonesdf$node != newdf$node[i],]
  tonesdf = tonesdf[tonesdf$node != newdf$ancnode[i],]
  if(nrow(tonesdf) == 0){
    disc_phymed_int = c(disc_phymed_int, 0)
    disc_phymeans_int2 = c(disc_phymeans_int2, 0)
    disc_phymeans_int_sd= c(disc_phymeans_int_sd, 0)
  }else if(nrow(tonesdf) == 1){
    disc_phymed_int = c(disc_phymed_int, median(tonesdf$Tones))
    disc_phymeans_int2 = c(disc_phymeans_int2, mean(tonesdf$Tones))
    disc_phymeans_int_sd= c(disc_phymeans_int_sd, 0)
  }else{
    disc_phymeans_int2 = c(disc_phymeans_int2, mean(tonesdf$Tones))
    disc_phymed_int = c(disc_phymed_int, median(tonesdf$Tones))
    disc_phymeans_int_sd= c(disc_phymeans_int_sd, sd(tonesdf$Tones))
  }
  
}
newdf$disc_phymed_int = disc_phymed_int
newdf$disc_phymeans_int = disc_phymeans_int2
newdf$disc_phymeans_int_sd = disc_phymeans_int_sd


write.csv(newdf, file = 'purelin_df.csv')

save(geodist,file = 'geodist.rda')
save(phydist,file = 'phylodist.rda')
